// USB Keyboard Scancode
//
// Keyboard model used for this project:
// MS-Tech LT-300U mini keyboard
// German layout
//
// info on Key coding:
// example for key 'a'
//     for the 3 numbers 28,0,97 :
//             28 represent the Fisrt scancode
//              0 represent the Second scancode , this is everytime 0 for a key 
//                with only 1 scancode
//             97 represent the ascii code for the 'a' character
//

// ** The French and English Keyboard layout are not done yet **
// ** They are copy from the German keyboard layout ;)        **




const unsigned char NbNormalKey  = 62;           //Key 0 to 62 = 63 Keys
const unsigned char NbShiftedKey = 48;           //Key 0 to 48 = 49 Keys
const unsigned char NbAltGrKey   = 10;           //Key 0 to 10 = 11 Keys
// German Keyboard Keyscan
const unsigned char NormalKey[63][3] = {
                                          28,0,97,    // a
                                          50,0,98,    // b
                                          33,0,99,    // c
                                          35,0,100,   // d
                                          36,0,101,   // e
                                          43,0,102,   // f
                                          52,0,103,   // g
                                          51,0,104,   // h
                                          67,0,105,   // i
                                          59,0,106,   // j
                                          66,0,107,   // k
                                          75,0,108,   // l
                                          58,0,109,   // m
                                          49,0,110,   // n
                                          68,0,111,   // o
                                          77,0,112,   // p
                                          21,0,113,   // q
                                          45,0,114,   // r
                                          27,0,115,   // s
                                          44,0,116,   // t
                                          60,0,117,   // u
                                          42,0,118,   // v
                                          29,0,119,   // w
                                          34,0,120,   // x
                                          26,0,121,   // y
                                          53,0,122,   // z
                                          69,0,48,    // 0
                                          22,0,49,    // 1
                                          30,0,50,    // 2
                                          38,0,51,    // 3
                                          37,0,52,    // 4
                                          46,0,53,    // 5
                                          54,0,54,    // 6
                                          61,0,55,    // 7
                                          62,0,56,    // 8
                                          70,0,57,    // 9
                                          224,108,2,  // Pos 1
                                          224,105,3,  // End
                                          102,0,8,    // Back Space
                                          90,0,13,    // Return
                                          118,0,27,   // ESC
                                          41,0,32,    // Space
                                          93,0,35,    // #
                                          91,0,43,    // +
                                          65,0,44,    // ,
                                          74,0,45,    // -
                                          73,0,46,    // .
                                          97,0,60,    // <
                                          14,0,94,    // ^
                                          224,113,127,// Delete
                                          85,0,180,   // acute accent
                                          78,0,225,   // sharp s
                                          82,0,132,   // 
                                          76,0,148,   // 
                                          84,0,129,   // 
                                          224,117,30,// up
                                          224,114,31,// down
                                          224,116,16,// right
                                          224,107,17,// left
                                          224,125,000,// page up  **not used yet**
                                          224,122,000,// page down**not used yet**
                                          224,240,000,// pause    **not used yet**
                                          224,18,000  // print    **not used yet**
};

const unsigned char ShiftedKey[49][3] = {
                                          28,0,65,    // A
                                          50,0,66,    // B
                                          33,0,67,    // C
                                          35,0,68,    // D
                                          36,0,69,    // E
                                          43,0,70,    // F
                                          52,0,71,    // G
                                          51,0,72,    // H
                                          67,0,73,    // I
                                          59,0,74,    // J
                                          66,0,75,    // K
                                          75,0,76,    // L
                                          58,0,77,    // M
                                          49,0,78,    // N
                                          68,0,79,    // O
                                          77,0,80,    // P
                                          21,0,81,    // Q
                                          45,0,82,    // R
                                          27,0,83,    // S
                                          44,0,84,    // T
                                          60,0,85,    // U
                                          42,0,86,    // V
                                          29,0,87,    // W
                                          34,0,88,    // X
                                          26,0,89,    // Y
                                          53,0,90,    // Z
                                          22,0,33,    // !
                                          30,0,34,    // "
                                          37,0,36,    // $
                                          46,0,37,    // %
                                          54,0,38,    // &
                                          93,0,39,    // '
                                          62,0,40,    // (
                                          70,0,41,    // )
                                          91,0,42,    // *
                                          73,0,58,    // :
                                          65,0,59,    // ;
                                          69,0,61,    // =
                                          97,0,62,    // >
                                          78,0,63,    // ?
                                          74,0,95,    // _
                                          85,0,96,    // ` grave accent
                                          14,0,167,   // 
                                          82,0,142,   // 
                                          76,0,153,   // 
                                          84,0,154,   // 
                                          38,0,18,    // Section sign
                                          61,0,47     // /
};

const unsigned char AltGrKey[11][3] = {
                                          21,0,64,    // @
                                          62,0,91,    // [
                                          78,0,92,    // \
                                          70,0,93,    // ]
                                          61,0,123,   // {
                                          97,0,124,   // |
                                          69,0,125,   // }
                                          91,0,126,   // ~
                                          36,0,128,   // 
                                          30,0,178,   // 
                                          58,0,181    // 
};

const unsigned char FunctionKey[12][3] = {               //**not used yet**
                                          5,0,000,    // F1
                                          6,0,000,    // F2
                                          4,0,000,    // F3
                                          12,0,000,   // F4
                                          3,0,000,    // F5
                                          11,0,000,   // F6
                                          131,0,000,  // F7
                                          10,0,000,   // F8
                                          1,0,000,    // F9
                                          9,0,000,    // F10
                                          120,0,000,  // F11
                                          7,0,000     // F12
};



const unsigned char Left_Shift[4] = {18,  0,240,18};
const unsigned char Right_Shift[4]= {89,  0,240,89};
const unsigned char Alt_Gr[4]     = {224,17,224,240};
const unsigned char Left_CTRL[4]  = {20,  0,240,20};  //**not used yet**
const unsigned char Tab[4]        = {13,  0,240,13};  //**not used yet**

// French Keyboard Keyscan
const unsigned char NormalKeyFR[63][3] = {
                                          28,0,97,    // a
                                          50,0,98,    // b
                                          33,0,99,    // c
                                          35,0,100,   // d
                                          36,0,101,   // e
                                          43,0,102,   // f
                                          52,0,103,   // g
                                          51,0,104,   // h
                                          67,0,105,   // i
                                          59,0,106,   // j
                                          66,0,107,   // k
                                          75,0,108,   // l
                                          58,0,109,   // m
                                          49,0,110,   // n
                                          68,0,111,   // o
                                          77,0,112,   // p
                                          21,0,113,   // q
                                          45,0,114,   // r
                                          27,0,115,   // s
                                          44,0,116,   // t
                                          60,0,117,   // u
                                          42,0,118,   // v
                                          29,0,119,   // w
                                          34,0,120,   // x
                                          26,0,121,   // y
                                          53,0,122,   // z
                                          69,0,48,    // 0
                                          22,0,49,    // 1
                                          30,0,50,    // 2
                                          38,0,51,    // 3
                                          37,0,52,    // 4
                                          46,0,53,    // 5
                                          54,0,54,    // 6
                                          61,0,55,    // 7
                                          62,0,56,    // 8
                                          70,0,57,    // 9
                                          224,108,2,  // Pos 1
                                          224,105,3,  // End
                                          102,0,8,    // Back Space
                                          90,0,13,    // Return
                                          118,0,27,   // ESC
                                          41,0,32,    // Space
                                          93,0,35,    // #
                                          91,0,43,    // +
                                          65,0,44,    // ,
                                          74,0,45,    // -
                                          73,0,46,    // .
                                          97,0,60,    // <
                                          14,0,94,    // ^
                                          224,113,127,// Delete
                                          85,0,180,   // acute accent
                                          78,0,225,   // sharp s
                                          82,0,132,   // 
                                          76,0,148,   // 
                                          84,0,129,   // 
                                          224,117,000,// up       **not used yet**
                                          224,114,000,// down     **not used yet**
                                          224,116,000,// right    **not used yet**
                                          224,107,000,// left     **not used yet**
                                          224,125,000,// page up  **not used yet**
                                          224,122,000,// page down**not used yet**
                                          224,240,000,// pause    **not used yet**
                                          224,18,000  // print    **not used yet**
};

const unsigned char ShiftedKeyFR[49][3] = {
                                          28,0,65,    // A
                                          50,0,66,    // B
                                          33,0,67,    // C
                                          35,0,68,    // D
                                          36,0,69,    // E
                                          43,0,70,    // F
                                          52,0,71,    // G
                                          51,0,72,    // H
                                          67,0,73,    // I
                                          59,0,74,    // J
                                          66,0,75,    // K
                                          75,0,76,    // L
                                          58,0,77,    // M
                                          49,0,78,    // N
                                          68,0,79,    // O
                                          77,0,80,    // P
                                          21,0,81,    // Q
                                          45,0,82,    // R
                                          27,0,83,    // S
                                          44,0,84,    // T
                                          60,0,85,    // U
                                          42,0,86,    // V
                                          29,0,87,    // W
                                          34,0,88,    // X
                                          26,0,89,    // Y
                                          53,0,90,    // Z
                                          22,0,33,    // !
                                          30,0,34,    // "
                                          37,0,36,    // $
                                          46,0,37,    // %
                                          54,0,38,    // &
                                          93,0,39,    // '
                                          62,0,40,    // (
                                          70,0,41,    // )
                                          91,0,42,    // *
                                          73,0,58,    // :
                                          65,0,59,    // ;
                                          69,0,61,    // =
                                          97,0,62,    // >
                                          78,0,63,    // ?
                                          74,0,95,    // _
                                          85,0,96,    // ` grave accent
                                          14,0,167,   // 
                                          82,0,142,   // 
                                          76,0,153,   // 
                                          84,0,154,   // 
                                          38,0,18,    // Section sign
                                          61,0,47     // /
};

const unsigned char AltGrKeyFR[12][3] = {
                                          21,0,64,    // @
                                          62,0,91,    // [
                                          78,0,92,    // \
                                          70,0,93,    // ]
                                          61,0,123,   // {
                                          97,0,124,   // |
                                          69,0,125,   // }
                                          91,0,126,   // ~
                                          36,0,128,   // 
                                          30,0,178,   // 
                                          58,0,181    // 
};

// English Keyboard Keyscan
const unsigned char NormalKeyEN[63][3] = {
                                          28,0,97,    // a
                                          50,0,98,    // b
                                          33,0,99,    // c
                                          35,0,100,   // d
                                          36,0,101,   // e
                                          43,0,102,   // f
                                          52,0,103,   // g
                                          51,0,104,   // h
                                          67,0,105,   // i
                                          59,0,106,   // j
                                          66,0,107,   // k
                                          75,0,108,   // l
                                          58,0,109,   // m
                                          49,0,110,   // n
                                          68,0,111,   // o
                                          77,0,112,   // p
                                          21,0,113,   // q
                                          45,0,114,   // r
                                          27,0,115,   // s
                                          44,0,116,   // t
                                          60,0,117,   // u
                                          42,0,118,   // v
                                          29,0,119,   // w
                                          34,0,120,   // x
                                          26,0,121,   // y
                                          53,0,122,   // z
                                          69,0,48,    // 0
                                          22,0,49,    // 1
                                          30,0,50,    // 2
                                          38,0,51,    // 3
                                          37,0,52,    // 4
                                          46,0,53,    // 5
                                          54,0,54,    // 6
                                          61,0,55,    // 7
                                          62,0,56,    // 8
                                          70,0,57,    // 9
                                          224,108,2,  // Pos 1
                                          224,105,3,  // End
                                          102,0,8,    // Back Space
                                          90,0,13,    // Return
                                          118,0,27,   // ESC
                                          41,0,32,    // Space
                                          93,0,35,    // #
                                          91,0,43,    // +
                                          65,0,44,    // ,
                                          74,0,45,    // -
                                          73,0,46,    // .
                                          97,0,60,    // <
                                          14,0,94,    // ^
                                          224,113,127,// Delete
                                          85,0,180,   // acute accent
                                          78,0,225,   // sharp s
                                          82,0,132,   // 
                                          76,0,148,   // 
                                          84,0,129,   // 
                                          224,117,000,// up       **not used yet**
                                          224,114,000,// down     **not used yet**
                                          224,116,000,// right    **not used yet**
                                          224,107,000,// left     **not used yet**
                                          224,125,000,// page up  **not used yet**
                                          224,122,000,// page down**not used yet**
                                          224,240,000,// pause    **not used yet**
                                          224,18,000  // print    **not used yet**
};

const unsigned char ShiftedKeyEN[49][3] = {
                                          28,0,65,    // A
                                          50,0,66,    // B
                                          33,0,67,    // C
                                          35,0,68,    // D
                                          36,0,69,    // E
                                          43,0,70,    // F
                                          52,0,71,    // G
                                          51,0,72,    // H
                                          67,0,73,    // I
                                          59,0,74,    // J
                                          66,0,75,    // K
                                          75,0,76,    // L
                                          58,0,77,    // M
                                          49,0,78,    // N
                                          68,0,79,    // O
                                          77,0,80,    // P
                                          21,0,81,    // Q
                                          45,0,82,    // R
                                          27,0,83,    // S
                                          44,0,84,    // T
                                          60,0,85,    // U
                                          42,0,86,    // V
                                          29,0,87,    // W
                                          34,0,88,    // X
                                          26,0,89,    // Y
                                          53,0,90,    // Z
                                          22,0,33,    // !
                                          30,0,34,    // "
                                          37,0,36,    // $
                                          46,0,37,    // %
                                          54,0,38,    // &
                                          93,0,39,    // '
                                          62,0,40,    // (
                                          70,0,41,    // )
                                          91,0,42,    // *
                                          73,0,58,    // :
                                          65,0,59,    // ;
                                          69,0,61,    // =
                                          97,0,62,    // >
                                          78,0,63,    // ?
                                          74,0,95,    // _
                                          85,0,96,    // ` grave accent
                                          14,0,167,   // 
                                          82,0,142,   // 
                                          76,0,153,   // 
                                          84,0,154,   // 
                                          38,0,18,    // Section sign
                                          61,0,47     // /
};

const unsigned char AltGrKeyEN[12][3] = {
                                          21,0,64,    // @
                                          62,0,91,    // [
                                          78,0,92,    // \
                                          70,0,93,    // ]
                                          61,0,123,   // {
                                          97,0,124,   // |
                                          69,0,125,   // }
                                          91,0,126,   // ~
                                          36,0,128,   // 
                                          30,0,178,   // 
                                          58,0,181    // 
};




